"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class CancerInterpretedGenome(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "analysisId",
        "reportRequestId",
        "reportURI",
        "reportedStructuralVariants",
        "reportedVariants",
        "versionControl",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_2_1_0 import reports as reports_2_1_0

        return {
            "reportedStructuralVariants": reports_2_1_0.ReportedSomaticStructuralVariants,
            "reportedVariants": reports_2_1_0.ReportedSomaticVariants,
            "versionControl": reports_2_1_0.VersionControl,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_2_1_0 import reports as reports_2_1_0

        return {
            "Gel_BioInf_Models.ReportedSomaticStructuralVariants": reports_2_1_0.ReportedSomaticStructuralVariants,
            "Gel_BioInf_Models.ReportedSomaticVariants": reports_2_1_0.ReportedSomaticVariants,
            "Gel_BioInf_Models.VersionControl": reports_2_1_0.VersionControl,
            "Gel_BioInf_Models.CancerInterpretedGenome": reports_2_1_0.CancerInterpretedGenome,
        }

    __slots__ = [
        "analysisId",
        "reportRequestId",
        "reportURI",
        "reportedStructuralVariants",
        "reportedVariants",
        "versionControl",
        "comments",
    ]

    def __init__(
        self,
        analysisId,
        reportRequestId,
        reportURI,
        reportedStructuralVariants,
        reportedVariants,
        versionControl,
        comments=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_2_1_0.CancerInterpretedGenome model.

        :param analysisId:
            This is the ID of the analysis carried out and is expected to be
            linked to the conditions and parameters     used to
            produce the clinical interpretation over this group of
            samples. It is critical to establish provenance.     It is
            expected that this id can be used to retrieve an analysis
            in the decision support/ variant exploration tools
        :type analysisId: str
        :param reportRequestId:
            This is the ID of the clinical interpretation request
        :type reportRequestId: str
        :param reportURI:
            URI where the company can upload files for this analysis
        :type reportURI: str
        :param reportedStructuralVariants:
        :type reportedStructuralVariants: list[ReportedSomaticStructuralVariants]
        :param reportedVariants:
        :type reportedVariants: list[ReportedSomaticVariants]
        :param versionControl:
            Model version number
        :type versionControl: VersionControl
        :param comments:
            Comments about the report
        :type comments: None | list[str]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.1.0"
